;
;	>>> ISO-Cart by JAC! <<<
;
;	Created for Sillyventure 2011 in Gdansk.
;
;	@com.wudsn.ide.asm.hardware=ATARI2600
;	@com.wudsn.ide.asm.mainsourcefile=ISO.asm

;===============================================================

	.proc start		;Start of the main part
	cld
	ldx #0
	txa
;	tay

clear	dex
	txs
	pha
	bne clear		;SP=$FF, X = A = 0, Y = undefined
	.endp			;End of start

	jsr effect.text.init

;===============================================================

	.proc main
frame_loop
	lsr swchb		;Reset pressed?
	bcc start		;Yes, reset

	jsr vsync_area

	.proc vblank_area
	lda #49			;The twister takes most of the time
	sta tim64t

	jmp call_vblank		;Call routine pointed to by vblank_ptr in other bank
return
	jsr effect.logo.vblank	;Animate the logo, takes 6 scan lines

sync	lda intim		;Sync with beam again
;	sta colubk		;Debug remaining time
;stop	bmi stop		;Time overrun
	bne sync
	sta wsync
	.endp			;End of vblank_area

;===============================================================

	.proc playfield

	jsr effect.logo.playfield

	jmp call_playfield
return
	jsr screen_off.with_sync

	jsr bar.white
	beq *+4			;Black lower & upper border if demo is finished
	lda #4			;Grey  lower & upper border if demo is running
	jsr bar.store
	.endp			;End of playfield

;===============================================================
	.proc overscan

line_count	= volatile_zp+0

	ldx #41
	stx tim64t		;Overscan time counter

	ldx #14
	stx colup0
	stx colup1
	lda #1			;<A>:=1, Player x1, 2 copies, close
	sta nusiz0
	sta nusiz1

	lda effect.sound.pattern_hi+$100
	cmp #4			;Logo flash starts

	jsr wait.wait20
	ldx #6			;JAC! 2011 in lower border
	sta resp0
	sta resp1
	bcs border_jac.start
	bcc border_atari.start

	.proc border_atari
	lda border-1,x
	ldy border+10-1,x
	sta grp0
	sty grp1
	jsr wait.wait20
	jsr wait.wait18
	lda border+20-1,x
	ldy border+30-1,x
	sta grp0
	sty grp1
start	sta wsync
	dex
	bne border_atari	;End of border_atari
	.endp
	assert_same_page border_atari
	beq border_end

	.align $100

	.proc border_jac
	lda border+5-1,x
	ldy border+15-1,x
	sta grp0
	sty grp1
	lda effect.sound.pattern_hi+$100
	clc
	adc #effect.logo.first_color
	and #$f0
	ora border.colors-1,x
	sta colup0
	sta colup1
	nop
	nop
	nop
	jsr wait.wait12
	lda border+25-1,x
	ldy border+35-1,x
	sta grp0
	sty grp1

start	sta wsync
	dex
	bne border_jac
	.endp			;End of border_jac
	assert_same_page border_jac


	
border_end
	stx grp0
	stx grp1

	jsr effect.sound.player	;Plays sound
	jsr effect.text.animate

	.proc flash
	lda flash_cnt		;Decrement flash counter?
	beq no_flash
	bpl dec_flash		;If the flash value is positive, it's decremented
	cmp #$ff
	beq no_flash 
	inc flash_cnt
	.byte $2c
dec_flash
	dec flash_cnt		;If the flash value is negative, it's incremented 
no_flash
	.endp

	inc cnt			;Increment frame counter

sync	lda intim		;Sync with beam again
;	sta colubk		;Debug remaining time
;stop	bmi stop		;Time overrun
	bne sync
	jmp frame_loop

	.local border
	ins "ISO-Border-JAC.pic"
colors	.byte $0e,$0a,$08,$06,$04
	.endl

	.endp			;End of overscan

	.proc vsync_area
	lda #$0e		;Create 3 lines of vsync=1 plus 1 line of vsync=0
	sta vblank		;Activate VBLANK bit 1 in scanline 308
loop
	sta wsync
	sta vsync
	lsr
	bne loop
	sta vblank		;Deactivate VBLANK bit 1 in scanline 0
	rts
	.endp

	.endp			;End of main

;===============================================================

	.proc effect

	icl "ISO-Stage.asm"
	icl "ISO-Logo.asm"
	icl "ISO-Sound.asm"
	icl "ISO-Text.asm"
		
	.endp			;End of effect
